/**
 * Copyright (c) 2005, TopCoder, Inc. All rights reserved.
 */
package com.topcoder.file.statistics.matcher;

import com.topcoder.util.config.Property;
import junit.framework.TestCase;
import com.topcoder.file.statistics.FileMatcher;
import java.io.File;


/**
 * <p>
 * Unit test cases for AnyFileMatcher.
 * </p>
 *
 * @author TCSDEVELOPER
 * @version 1.0
 */
public class AnyFileMatcherTests extends TestCase {
    /**
     * <p>
     * Creation test.
     * </p>
     *
     * <p>
     * Verifies the constructor - AnyFileMatcher().
     * </p>
     */
    public void testAnyFileMatcher1() {
        assertTrue("Unable to instantiate AnyFileMatcher.", new AnyFileMatcher() instanceof FileMatcher);
    }

    /**
     * <p>
     * Creation test.
     * </p>
     *
     * <p>
     * Verifies the constructor - AnyFileMatcher(Property).
     * </p>
     */
    public void testAnyFileMatcher2() {
        assertNotNull("Unable to instantiate AnyFileMatcher.", new AnyFileMatcher(new Property("foo")));
    }

    /**
     * <p>
     * Creation test.
     * </p>
     *
     * <p>
     * Verifies the constructor - AnyFileMatcher(Property) with null argument. NullPointerException should be thrown.
     * </p>
     */
    public void testAnyFileMatcher3() {
        try {
            new AnyFileMatcher(null);
            fail("NullPointerException should be thrown");
        } catch (NullPointerException e) {
            // success
        }
    }

    /**
     * <p>
     * Tests the match method. The result should always be true.
     * </p>
     */
    public void testMatch1() {
        assertTrue("The result should always be true", new AnyFileMatcher().match(new File("foo")));
    }

    /**
     * <p>
     * Tests the match method with null argument. NullPointerException should be thrown.
     * </p>
     */
    public void testMatch2() {
        try {
            new AnyFileMatcher().match(null);
            fail("NullPointerException should be thrown");
        } catch (NullPointerException e) {
            // success
        }
    }
}
