/**
 * Copyright (c) 2005, TopCoder, Inc. All rights reserved.
 */
package com.topcoder.file.statistics;

/**
 * <p>A Helper calss in statistics package.</p>
 *
 * @author TCSDEVELOPER
 *
 * @version 1.0
 */
class FileStatisticsHelper {

    /**
     * Private constructor to prevent this class be instantiated.
     */
    private FileStatisticsHelper() {
        // empty
    }


    /**
     * Checks whether the given Object is null.
     *
     * @param arg the argument to check
     * @param name the name of the argument
     * @throws NullPointerException if the given Object is null
     */
    static void checkNull(Object arg, String name) {
        if (arg == null) {
            throw new NullPointerException(name + " should not be null.");
        }
    }

    /**
     * Checks whether the given String is empty.
     *
     * @param arg the argument to check
     * @param name the name of the argument
     * @throws NullPointerException if the given String is null
     * @throws IllegalArgumentException if the given String is empty
     */
    static void checkEmpty(String arg, String name) {
        if (arg == null) {
            throw new NullPointerException(name + " should not be null.");
        }
        if (arg.trim().length() == 0) {
            throw new IllegalArgumentException(name + " should not be empty.");
        }
    }
}