/**
 * Copyright (c) 2005, TopCoder, Inc. All rights reserved.
 */
package com.topcoder.file.statistics.accuracytests;

import junit.framework.TestCase;

import com.topcoder.file.statistics.Metric;


/**
 * <p>
 * Unit test cases for Metric
 * </p>
 *
 * @author cucu
 * @version 1.0
 */
public class MetricAccuracyTests extends TestCase {

    /**
     * Test the whole Metric class for accuracy in this method.
     */
    public void testMetric() {
        Metric m1 =  new Metric("metric1", "displayName 1", "descritpion 1");
        Metric m2 =  new Metric("metric2", "displayName 2", "descritpion 2");
        Metric m3 =  new Metric("metric1", "displayName 3", "descritpion 3");

        // test  getters
        assertEquals("bad Name retrieved", "metric1", m1.getName());
        assertEquals("bad DisplayName retrieved", "displayName 1", m1.getDisplayName());
        assertEquals("bad Description retrieved", "descritpion 1", m1.getDescription());

        // test Equals
        assertTrue("m1 expected to be equal to m1", m1.equals(m1));
        assertTrue("m1 expected to be equal to m3", m1.equals(m3));
        assertFalse("m1 not expected to be equal to m2", m1.equals(m2));

        // test GetHashCode
        assertEquals("m1 and m3 should have the same hashcode", m1.hashCode(), m3.hashCode());
        assertFalse("m1 and m2 should not have the same hashcode", m1.hashCode() == m2.hashCode());
    }

}
