/**
 * Copyright (c) 2005, TopCoder, Inc. All rights reserved.
 */
package com.topcoder.file.statistics.accuracytests;

import junit.framework.Assert;
import junit.framework.TestCase;

import com.topcoder.file.statistics.Metric;
import com.topcoder.file.statistics.StatsResult;


/**
 * <p>
 * Unit test cases for StatsResults
 * </p>
 *
 * @author cucu
 * @version 1.0
 */
public class StatsResultAccuracyTests extends TestCase {

    /**
     * Metric used for testing
     */
    private Metric m1 =  new Metric("metric1", "displayName 1", "descritpion 1");


    /**
     * Metric used for testing
     */
    private Metric m2 =  new Metric("metric2", "displayName 2", "descritpion 2");

    /**
     * Object to be tested.
     */
    private StatsResult sr;


    /**
     * Set up a stats result with two metrics
     */
    public void setUp() {
        sr = new StatsResult();
        sr.setStat(m1, 10);
        sr.setStat(m2, 20);
    }


    /**
     * Test getStat method
     */
    public void testGetStat()     {
        assertEquals("bad get/set indexer", 10, sr.getStat(m1));
        assertEquals("bad get/set indexer", 20, sr.getStat(m2));
    }

    /**
     *  Test Metrics property
     */
    public void testMetrics() {
        assertTrue("m1 not included in the metrics list", sr.getMetrics().contains(m1));
        assertTrue("m2 not included in the metrics list", sr.getMetrics().contains(m2));
    }

    /**
     * Test using the copy constructor
     */
    public void testCopyConstructor() {
        // Test copy constructor
        StatsResult sr2 = new StatsResult(sr);
        assertEquals("copy constructor problem", 10, sr.getStat(m1));
        assertEquals("copy constructor problem", 20, sr.getStat(m2));
    }

    /**
     * Test the Aggregate method
     */
    public void testAggregate() {
        StatsResult sr2 = new StatsResult();
        sr2.setStat(m1, 100);
        sr.aggregate(sr2);

        assertEquals("aggregation problem", 110, sr.getStat(m1));
        assertEquals("aggregation problem", 20, sr.getStat(m2));
    }

}
