/*
 * $(#)ConfigurationExceptionTests.java		Sep 6, 2005
 * 
 * Copyright (c) 2005, TopCoder Inc. All rights reserved.
 */

package com.topcoder.file.statistics.failuretests;

import junit.framework.TestCase;

import com.topcoder.file.statistics.ConfigurationException;

/**
 * This test case contains the failure tests for the <code>ConfigurationException</code>
 * class.
 *
 * @author MPhk
 * @version 1.0
 */
public class ConfigurationExceptionTests extends TestCase {

    /**
     * Verifies whether the ConfigurationException(String) constructor properly behaves 
     * when receives null arguments. It should not throw any exception.
     */
    public void testConfigurationException1() {
        try {
            new ConfigurationException(null);
        } catch (Exception e) {
            fail("Exception not expected when calling ConfigurationException(String)");
        }
    }
    
    /**
     * Verifies whether the ConfigurationException(String, Throwable) constructor properly behaves 
     * when receives null arguments. It should not throw any exception.
     */
    public void testConfigurationException2() {
        try {
            new ConfigurationException(null, new Exception());
        } catch (Exception e) {
            fail("Exception not expected when calling ConfigurationException(String, Throwable)");
        }
    }
    
    /**
     * Verifies whether the ConfigurationException(String, Throwable) constructor properly behaves 
     * when receives null arguments. It should not throw any exception.
     */
    public void testConfigurationException3() {
        try {
            new ConfigurationException("msg", null);
        } catch (Exception e) {
            fail("Exception not expected when calling ConfigurationException(String, Throwable)");
        }
    }
    
    /**
     * Verifies whether the ConfigurationException(String) constructor properly behaves 
     * when receives null arguments. It should not throw any exception.
     */
    public void testConfigurationException4() {
        try {
            new ConfigurationException(null, null);
        } catch (Exception e) {
            fail("Exception not expected when calling ConfigurationException(String, Throwable)");
        }
    }
    
}
