/*
 * $(#)FileMatchingExceptionTests.java		Sep 6, 2005
 * 
 * Copyright (c) 2005, TopCoder Inc. All rights reserved.
 */

package com.topcoder.file.statistics.failuretests;

import junit.framework.TestCase;

import com.topcoder.file.statistics.FileMatchingException;

/**
 * This test case contains the failure tests for the <code>FileMatchingException</code>
 * class.
 *
 * @author MPhk
 * @version 1.0
 */
public class FileMatchingExceptionTests extends TestCase {

    /**
     * Verifies whether the FileMatchingException(String) constructor properly behaves 
     * when receives null arguments. It should not throw any exception.
     */
    public void testFileMatchingException1() {
        try {
            new FileMatchingException(null);
        } catch (Exception e) {
            fail("Exception not expected when calling FileMatchingException(String)");
        }
    }
    
    /**
     * Verifies whether the FileMatchingException(String, Throwable) constructor properly behaves 
     * when receives null arguments. It should not throw any exception.
     */
    public void testFileMatchingException2() {
        try {
            new FileMatchingException(null, new Exception());
        } catch (Exception e) {
            fail("Exception not expected when calling FileMatchingException(String, Throwable)");
        }
    }
    
    /**
     * Verifies whether the FileMatchingException(String, Throwable) constructor properly behaves 
     * when receives null arguments. It should not throw any exception.
     */
    public void testFileMatchingException3() {
        try {
            new FileMatchingException("msg", null);
        } catch (Exception e) {
            fail("Exception not expected when calling FileMatchingException(String, Throwable)");
        }
    }
    
    /**
     * Verifies whether the FileMatchingException(String) constructor properly behaves 
     * when receives null arguments. It should not throw any exception.
     */
    public void testFileMatchingException4() {
        try {
            new FileMatchingException(null, null);
        } catch (Exception e) {
            fail("Exception not expected when calling FileMatchingException(String, Throwable)");
        }
    }
    
}
