/*
 * $(#)StatsReportingExceptionTests.java		Sep 6, 2005
 * 
 * Copyright (c) 2005, TopCoder Inc. All rights reserved.
 */

package com.topcoder.file.statistics.failuretests;

import com.topcoder.file.statistics.StatsReportingException;

import junit.framework.TestCase;

/**
 * This test case contains the failure tests for the <code>StatsReportingException</code>
 * class.
 *
 * @author MPhk
 * @version 1.0
 */
public class StatsReportingExceptionTests extends TestCase {

    /**
     * Verifies whether the StatsReportingException(String) constructor properly behaves 
     * when receives null arguments. It should not throw any exception.
     */
    public void testStatsReportingException1() {
        try {
            new StatsReportingException(null);
        } catch (Exception e) {
            fail("Exception not expected when calling StatsReportingException(String)");
        }
    }
    
    /**
     * Verifies whether the StatsReportingException(String, Throwable) constructor properly behaves 
     * when receives null arguments. It should not throw any exception.
     */
    public void testStatsReportingException2() {
        try {
            new StatsReportingException(null, new Exception());
        } catch (Exception e) {
            fail("Exception not expected when calling StatsReportingException(String, Throwable)");
        }
    }
    
    /**
     * Verifies whether the StatsReportingException(String, Throwable) constructor properly behaves 
     * when receives null arguments. It should not throw any exception.
     */
    public void testStatsReportingException3() {
        try {
            new StatsReportingException("msg", null);
        } catch (Exception e) {
            fail("Exception not expected when calling StatsReportingException(String, Throwable)");
        }
    }
    
    /**
     * Verifies whether the StatsReportingException(String) constructor properly behaves 
     * when receives null arguments. It should not throw any exception.
     */
    public void testStatsReportingException4() {
        try {
            new StatsReportingException(null, null);
        } catch (Exception e) {
            fail("Exception not expected when calling StatsReportingException(String, Throwable)");
        }
    }
    
}
