// BEGIN CUT HERE
/*
// PROBLEM STATEMENT
//
You will be given a 2-dimensional grid of letters and a length.
Write a method to count the total number of distinct paths of consecutive letters of the given length, starting at 'A'.
Paths can step from one square in the grid to any adjacent square (horizontally, vertically, or
diagonally).



For example, in the following grid, there are 7 paths of consecutive letters from 'A' to 'C':



    { "ABC",
      "CBZ",
      "CZC",
      "BZZ",
      "ZAA" }

    A B C    A . C    A B .    A . .    A . .    A . .    . . .
    . . .    . B .    C . .    C B .    . B .    . B .    . . .
    . . .    . . .    . . .    . . .    C . .    . . C    C . .
    . . .    . . .    . . .    . . .    . . .    . . .    B . .
    . . .    . . .    . . .    . . .    . . .    . . .    . A .
    (spaces are for clarity only)



so, for this grid and a length of 3, your method should return 7.



If there are more than 1,000,000,000 paths, your method should return 1,000,000,000.


DEFINITION
Class:AlphabetCount
Method:count
Parameters:vector <string>, int
Returns:int
Method signature:int count(vector <string> grid, int length)


CONSTRAINTS
-grid will contain between 1 and 50 elements, inclusive.
-Each element of grid will be between 1 and 50 characters long, inclusive.
-Each element of grid will have the same length.
-grid will contain only uppercase letters ('A'-'Z').
-length will be between 1 and 26, inclusive.


EXAMPLES

0)
{ "ABC",
  "CBZ",
  "CZC",
  "BZZ",
  "ZAA" }
3

Returns: 7

This is the example from the problem statement.

1)
{ "AAAA",
  "AAAA",
  "AAAA" }
1

Returns: 12

2)
{ "ABAB",
  "BABA",
  "ABAB",
  "BABA" }
2

Returns: 24

3)
{ "HIJKLMNOPQZZZONMLKHIDZYQR",
  "GYXWVUTSRASTZZPSTUJGECPXS",
  "FZABCDEFARQPUQRAAAVWFBOWT",
  "EONMJIHGAJMNOVAAAAAYXANUV",
  "DCBLKDEFIEKLEDWAAAZFGHMLK",
  "UVAZYBCGHFDFCAYXNPQZEDIJA",
  "TSWXAKLZGCZBGZIJOMZRUTCBZ",
  "RQPONMJIHBAZZHZZKLZZSVWXY" }
26

Returns: 7

4)
{ "CZC",
  "ZBZ",
  "AZA" }

3

Returns: 4

5)
{ "ABCDEFGHIJKLMNOPQRSTUVWXYZ",
  "ABCDEFGHIJKLMNOPQRSTUVWXYZ",
  "ABCDEFGHIJKLMNOPQRSTUVWXYZ" }
26

Returns: 1000000000

6)
{ "BDBCBACABDDCCADCBDDCBDDDBCCCCABACADDDCCCBADDDBADCA",
  "DCBBBACBDBACCADABCCAABACDBADBCBBABACBCADADCBDABBBD" }

4

Returns: 20

*/
// END CUT HERE
#line 126 "AlphabetCount.cpp"
#include <string>
#include <vector>
#include <cmath>
#include <sstream>
#include <iostream>
#include <algorithm>
#include <numeric>

using namespace std;

long long tab[100][100];

//-----------------------------------------------------------------------------------------------------------------------------
class AlphabetCount {
    public:


    int count(vector <string> grid, int length) {
                   for(int i=0; i < 100; i++)
                     for (int j=0; j < 100; j++)
                         tab[i][j]=0;

bool first = true;
long long tot=0;
       for (char c = 'A' + length -1; c >= 'A'; c--) {
           for(int i=0; i < grid.size(); i++) {
             for (int j=0; j < grid[i].length(); j++) {
                 if (grid[i][j] == c) {
                      if (first) tab[i][j] = 1;
                      else {
                          long long sum=0;
                          for (int y=i-1; y <= i+1; y++)
                             for(int x=j-1; x <= j+1; x++)
                                if (y >= 0 && x >= 0 && y < grid.size() && x < grid[0].size() && grid[y][x] == (c+1))
                                     sum += tab [y][x];
                            tab [i][j]=sum;
                      }
                      if (c=='A') {
                          tot += tab[i][j];
                          if (tot>1000000000ll) tot = 1000000000ll;
                      }
                 }
//                 cout << tab[i][j] << "  ";
             }
//             cout << endl;
           }
           first = false;
       }
       return tot;
    }

};
