<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="html"/>

<xsl:template match="report">
<p><b><font color="Red">File Statistics Report</font></b></p>
<xsl:apply-templates select="files"/>
<xsl:apply-templates select="directories"/>
<xsl:apply-templates select="aliases"/>
<xsl:apply-templates select="overall"/>
</xsl:template>

<xsl:template match="files">
<p><b>Files</b></p>
<xsl:apply-templates select="file"/>
</xsl:template>

<xsl:template match="file">
	<xsl:value-of select="@name"/>
	<br/>
	<xsl:apply-templates select="line"/>
	<br/>
</xsl:template>


<xsl:template match="line">
    <b>line: </b>
	<xsl:value-of select="text()"/>
	<br/>
	<xsl:apply-templates select="line"/>
</xsl:template>

<xsl:template match="directories">
<p><b>Direcotries</b></p>
<xsl:apply-templates select="directory"/>
</xsl:template>

<xsl:template match="directory">
	<xsl:value-of select="@name"/>
	<br/>
	<xsl:apply-templates select="line"/>
	<br/>
</xsl:template>

<xsl:template match="aliases">
<p><b>Aliases</b></p>
<xsl:apply-templates select="alias"/>
</xsl:template>

<xsl:template match="alias">
	<xsl:value-of select="@name"/>
	<br/>
	<xsl:apply-templates select="line"/>
	<br/>
</xsl:template>

<xsl:template match="overall">

    <p><b>Overall</b></p>
	<xsl:apply-templates select="line"/>
	<br/>
</xsl:template>

</xsl:stylesheet>
